diff --git a/meta/classes/.imagetypes_vm.bbclass.swn b/meta/classes/.imagetypes_vm.bbclass.swn
new file mode 100644
index 0000000000000000000000000000000000000000..88cdc4380ce74795279686cd6bb71c428157ecf9
GIT binary patch
diff --git a/meta/classes/imagetypes_vm.bbclass b/meta/classes/imagetypes_vm.bbclass
index 41f2af067331..cd56d31b0fe0 100644
--- a/meta/classes/imagetypes_vm.bbclass
+++ b/meta/classes/imagetypes_vm.bbclass
@@ -6,6 +6,7 @@
 
 inherit buildchroot
 
+FILESEXTRAPATHS:prepend = "${LAYERDIR_core}/recipes-core/images:"
 OVF_TEMPLATE_FILE ?= "vm-img-virtualbox.ovf.tmpl"
 IMAGE_SRC_URI:ova = "file://${OVF_TEMPLATE_FILE}"
 
diff --git a/meta-isar/recipes-core/images/virtualbox/vm-img-virtualbox.ovf.tmpl b/meta/recipes-core/images/virtualbox/vm-img-virtualbox.ovf.tmpl
similarity index 100%
rename from meta-isar/recipes-core/images/virtualbox/vm-img-virtualbox.ovf.tmpl
rename to meta/recipes-core/images/virtualbox/vm-img-virtualbox.ovf.tmpl
diff --git a/meta-isar/recipes-core/images/vmware/vm-img-vmware.ovf.tmpl b/meta/recipes-core/images/vmware/vm-img-vmware.ovf.tmpl
similarity index 100%
rename from meta-isar/recipes-core/images/vmware/vm-img-vmware.ovf.tmpl
rename to meta/recipes-core/images/vmware/vm-img-vmware.ovf.tmpl